<?php
	/*
        Répare les photos cassées en les retirant depuis Polaris
		
		Usage :
		repair_photos <tlr>
                    
        Avec :
        - tlr : adresse du tlr
	*/	
    
    $opts = getopt("", array("cfg:", "tlr:"));

	if (!isset($opts["tlr"]) || empty($opts["tlr"]) || !isset($opts["cfg"]) || empty($opts["cfg"]))
	{
        echo "Usage php ".$argv[0]." --cfg /path/to/config.inc.php directory --tlr xx.xx.xx.xx:3000\n";
        die();
    }
    
	// Autodétection de l'emplacement de Prestashop (attention au lien symbolique sur plateforme de dev)    
	    
	// Inclusion de la configuration
    require($opts["cfg"].'/config.inc.php');		
    require_once(_PS_ROOT_DIR_ . "/modules/polarislink/classes/PolarisLinkAPI.php");
	require_once(_PS_ROOT_DIR_ . "/modules/polarislink/models/PolarisLinkPhotos.php");	
    
	class PhotoRepair
	{
        private $db;
        private $systemLang;

		public function __construct()
		{
            $this->systemLang = Configuration::get('PS_LANG_DEFAULT');
		}
		
		/*
			Importation
		*/
		function run($tlr)
		{
            // Base de données
            $this->db = Db::getInstance();
            if (!$this->db)
                die ("Erreur d'accès à la base de données");

            // Pas de cache !
            $this->db->disableCache();

            // Chargement de toutes les photos produits
            $photosProduits = [];
            foreach ($this->db->ExecuteS("SELECT * FROM `"._DB_PREFIX_."image`") as $row)
            {
                $imgPath = _PS_PROD_IMG_DIR_.Image::getImgFolderStatic($row["id_image"]).$row["id_image"].".jpg";
                $photosProduits[basename(readlink($imgPath))] = $row["id_image"];                
            }

            // Chargement de tous les produits
            $photos = $this->db->ExecuteS("SELECT * FROM `"._DB_PREFIX_."polarislink_photos` ORDER BY `id_photos` DESC");
            $c_photos = count($photos);
            $c_idx = 0;
            foreach($photos as $row)
            {
                echo sprintf("%d/%d\n", ++$c_idx, $c_photos);

                // On vérifie que la photo est correcte
                $filename = PolarisLinkAPI::GetPolarisPhotoPathFor($row["id_link"], $row["id_polaris"]);

                if (!file_exists($filename) || $row["etag"] != md5_file($filename)."-".filesize($filename))
                {
                    // Sinon, on l'affiche
                    echo "Repairing : ". $filename . " : ";

                    echo "downloading... ";
                    if ($inStream = fopen("http://" . $tlr . "/core/api/Medias.FetchPhoto?photoSize=original&noPhoto=" . $row["id_polaris"], "r"))
                    {
                        if ($outStream = fopen($filename, "w"))
                        {
                            stream_copy_to_stream($inStream, $outStream);
                            fclose($outStream);

                            if (isset($photosProduits[$row["id_polaris"].".jpg"]))
                            {
                                $imgId = $photosProduits[$row["id_polaris"].".jpg"];
                                $pathToClean = _PS_PROD_IMG_DIR_.Image::getImgFolderStatic($imgId);
                                foreach (scandir($pathToClean) as $fn)
                                {
                                    if (substr($fn, 0, strlen($imgId) + 1 ) == $imgId."-")
                                        unlink($pathToClean.$fn);
                                }

                                echo "Building... ";
                                // Génération des miniatures !
                                $imagesTypes = ImageType::getImagesTypes('products');
                                $generate_hight_dpi_images = (bool)Configuration::get('PS_HIGHT_DPI');

                                foreach ($imagesTypes as $imageType) 
                                {
                                    if (!ImageManager::resize($filename, $pathToClean.$imgId.'-'.stripslashes($imageType['name']).'.jpg', $imageType['width'], $imageType['height'], 'jpg')) {
                                        echo sprintf("une erreur est survenue lors de la génération du thumbnail de l'image: %s", stripslashes($imageType['name']));
                                        continue;
                                    }

                                    if ($generate_hight_dpi_images) {
                                        if (!ImageManager::resize($filename, $pathToClean.$imgId.'-'.stripslashes($imageType['name']).'2x.jpg', (int)$imageType['width']*2, (int)$imageType['height']*2, 'jpg')) {
                                            echo sprintf("une erreur est survenue lors de la génération du thumbnail haute définition de l'image: %s", stripslashes($imageType['name']));
                                            continue;
                                        }
                                    }
                                }                                

                                echo "OK !\n";
                            }
                            else
                                echo "Unable to find presta img !\n";
                        }
                        else
                            echo "Unable to write file !\n";
                        fclose($inStream);
                    }
                    else
                        echo "Unable to download file !\n";                 
                }
            }
        }
    }
    
	$spliter = new PhotoRepair();
    $spliter->run(
                $opts["tlr"]
            );
